/********************************************************************************************************************/
/* Periscope for SQL Server Upgrade Script                                                                          */
/* From Version: ANY												    */
/* To Version: 5.5												    */
/*													            */
/* README:  Make sure all Periscope monitoring services are stopped through the management console		    */
/*	    prior to running this script.									    */
/********************************************************************************************************************/

set nocount on
print 'Starting Script......'
print 'Creating Indexes on Base tables......'
go

declare a cursor for select name from sysobjects where type = 'u' and name not like '%_pscope' and name not like '%_blocking' and name not like '%_sysperf' and name not like '%_alerts' and id not in (select id from sysindexes where name = 'IX_SPID') and id in (select id from syscolumns where name = 'SPID')
declare @a varchar(200)
open a
fetch a into @a
while @@fetch_status <> -1
begin
exec ('create clustered index IX_SPID on [' + @a + '] (spid)')
fetch a into @a
end
deallocate a
go

print 'Creating Indexes on Reporting tables......'
go

declare a cursor for select name from sysobjects where type = 'u' and name like '%_pscope' and id not in (select id from sysindexes where name = 'IX_HID') and id in (select id from syscolumns where name = 'HID')
declare @a varchar(200)
open a
fetch a into @a
while @@fetch_status <> -1
begin
exec ('create index IX_HID on [' + @a + '] (hid)')
fetch a into @a
end
deallocate a
go

print 'Adding new column on Reporting tables......'
go

declare a cursor for select name from sysobjects where type = 'u' and name like '%_pscope' and id not in (select id from syscolumns where name = 'waittime')
declare @a varchar(200)
open a
fetch a into @a
while @@fetch_status <> -1
begin
exec ('alter table [' + @a + '] add WaitTime int null')
fetch a into @a
end
deallocate a
go

print 'Dropping stored procedures......'
go

declare a cursor for select name from sysobjects where type = 'p' 
declare @a varchar(200)
open a
fetch a into @a
while @@fetch_status <> -1
begin
exec ('drop procedure [' + @a + ']')
fetch a into @a
end
deallocate a
go

print 'Adding AlertID......'
declare a cursor for select name from sysobjects where type = 'u' and name like '%_alerts' and id not in (select id from syscolumns where name = 'AlertID')
declare @a varchar(200)
open a
fetch a into @a
while @@fetch_status <> -1
begin
exec ('alter table [' + @a + '] add AlertID int not null identity (1,1)')
fetch a into @a
end
deallocate a
go

print 'Adding DiskSpace......'
declare a cursor for select name from sysobjects where type = 'u' and name like '%_sysperf' and id not in (select id from syscolumns where name = 'DiskSpace')
declare @a varchar(200)
open a
fetch a into @a
while @@fetch_status <> -1
begin
exec ('alter table [' + @a + '] add DiskSpace int')
fetch a into @a
end
deallocate a
go

print ''
print 'Periscope for SQL Server v5.6 Upgrade Script Complete'
go